<?php
/**
 * ###############################################
 *
 * SWIFT Framework
 * _______________________________________________
 *
 * @author         Varun Shoor
 *
 * @package        SWIFT
 * @copyright      Copyright (c) 2001-2012, Kayako
 * @license        http://www.kayako.com/license
 * @link           http://www.kayako.com
 *
 * ###############################################
 */

/**
 * SugarCRM Users Model
 *
 * @author Rahul Bhattacharya
 */

class SWIFT_SugarCRMUser extends SWIFT_Model
{
    // Table Name
    const TABLE_NAME = 'users';

    /**
     * Constructor
     *
     * return boolean True on Success, or False Otherwise
     *
     * @author Rahul Bhattacharya
     */
    public function __construct()
    {
        parent::__construct();

        return true;
    }


    /**
     * Destructor
     *
     * return boolean True on Success, or False Otherwise
     *
     * @author Rahul Bhattacharya
     */
    public function __destruct()
    {
        parent::__destruct();

        return true;
    }


    /**
     * Responsible to insert the sugarcrm users data
     *
     * @param $_postArray
     *
     * @return bool
     *
     * @author Rahul Bhattacharya
     */
    public function InsertUsers($_postArray)
    {
        if (self::CheckUserExistence($_postArray['id'])) {
			$_SWIFT = SWIFT::GetInstance();

           $_SWIFT->Database->AutoExecute(TABLE_PREFIX . self::TABLE_NAME, array(
                'userorganizationid' => $_postArray['userorganizationid'],
				'usergroupid'		=>  SWIFT_UserGroup::RetrieveDefaultUserGroupID(SWIFT_UserGroup::TYPE_REGISTERED),
                'fullname'           => htmlspecialchars_decode($_postArray['fullname'], ENT_QUOTES),
                'isenabled'          => '1',
                'phone'              => $_postArray['phone'],
                'userrole'           => '1',
                'isvalidated'        => '1',
                'userdesignation'    => $_postArray['userdesignation'],
                'dateline'           => intval($_postArray['dateline']),
            ), 'INSERT');

            $_lastInsertID = $_SWIFT->Database->Insert_ID();

            $_SWIFT->Database->AutoExecute(TABLE_PREFIX . 'useremails', array(
                'linktypeid' => $_lastInsertID,
                'linktype'   => '1',
                'email'      => $_postArray['email'],
            ), 'INSERT');

            $_SWIFT->Database->AutoExecute(TABLE_PREFIX . 'sugarcrmuserinfo', array(
                'userid'  => $_postArray['id'],
                'kuserid' => $_lastInsertID,
            ), 'INSERT');
        }

        return true;
    }

	/**
	 * Responsible for checking userid from swsugarcrmuserinfo table
	 *
	 * @param $_userId
	 *
	 * @param string $_column
	 *
	 * @return bool
	 *
	 * @author Rahul Bhattacharya
	 */
   static public function CheckUserExistence($_userId, $_column = 'userid')
    {
        //query to fetch the sugar account id from swsugarcrmaccountinfo
        $_SWIFT = SWIFT::GetInstance();
		$_SWIFT->Database->Query("SELECT * FROM " . TABLE_PREFIX . "sugarcrmuserinfo WHERE " . $_column . " = '" . $_userId . "'");
        while ($_SWIFT->Database->NextRecord()) {
            $_sugarcrmUserInfoId = $_SWIFT->Database->Record['sugarcrmuserinfoid'];
        }

        if (!isset($_sugarcrmUserInfoId)) {
            return true;
        }

        return false;
    }
}